<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: exampleSquatToStand.m</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('exampleSquatToStand_8m-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">exampleSquatToStand.m</div>  </div>
</div><!--header-->
<div class="contents">
<p>This is an example that predicts a squat-to-stand movement and optimizes the stiffness of an assistive passive device. This example is used in hands-on workshops, and accordingly has blanks that users must fill in. See <a class="el" href="exampleSquatToStand_answers_8m-example.html">exampleSquatToStand_answers.m</a> for a completed version.</p>
<div class="fragment"><div class="line"><span class="keyword">function</span> exampleSquatToStand</div>
<div class="line"> </div>
<div class="line">%% Part 0: Load the Moco libraries and pre-configured Models.</div>
<div class="line">import org.opensim.modeling.*;</div>
<div class="line">% These models are provided <span class="keywordflow">for</span> you (i.e., they are not part of Moco).</div>
<div class="line">torqueDrivenModel = getTorqueDrivenModel();</div>
<div class="line">muscleDrivenModel = getMuscleDrivenModel();</div>
<div class="line"> </div>
<div class="line">%% Part 1: Torque-driven Predictive Problem</div>
<div class="line">% Part 1a: Create a new MocoStudy.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Part 1b: Initialize the problem and set the model.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Part 1c: Set bounds on the problem.</div>
<div class="line">%</div>
<div class="line">% problem.setTimeBounds(initial_bounds, final_bounds)</div>
<div class="line">% problem.setStateInfo(path, trajectory_bounds, inital_bounds, final_bounds)</div>
<div class="line">%</div>
<div class="line">% All *_bounds arguments can be set to a range, [lower upper], or to a</div>
<div class="line">% single value (equal lower and upper bounds). Empty brackets, [], indicate</div>
<div class="line">% using default bounds (if they exist). You may set multiple state infos at</div>
<div class="line">% once using setStateInfoPattern():</div>
<div class="line">%</div>
<div class="line">% problem.setStateInfoPattern(pattern, trajectory_bounds, inital_bounds, ...</div>
<div class="line">%       final_bounds)</div>
<div class="line">%</div>
<div class="line">% This function supports regular expressions in the &#39;pattern&#39; argument;</div>
<div class="line">% use <span class="stringliteral">&#39;.*&#39;</span> to match any substring of the state/control path</div>
<div class="line">% For example, the following will <span class="keyword">set</span> all coordinate value state infos:</div>
<div class="line">%</div>
<div class="line">% problem.setStateInfoPattern(<span class="stringliteral">&#39;/path/to/states/.*/value&#39;</span>, ...)</div>
<div class="line"> </div>
<div class="line">% Time bounds</div>
<div class="line">problem.setTimeBounds( );</div>
<div class="line"> </div>
<div class="line">% <a class="code" href="namespaceOpenSim.html#a4286a47452ef915e89270cee497faaeca52f5e0bc3859bc5f5e25130b6c7e8881">Position</a> bounds: the model should start in a squat and finish </div>
<div class="line">% standing up.</div>
<div class="line">problem.setStateInfo(<span class="stringliteral">&#39;/jointset/hip_r/hip_flexion_r/value&#39;</span>, );</div>
<div class="line">problem.setStateInfo(<span class="stringliteral">&#39;/jointset/knee_r/knee_angle_r/value&#39;</span>, );</div>
<div class="line">problem.setStateInfo(<span class="stringliteral">&#39;/jointset/ankle_r/ankle_angle_r/value&#39;</span>, );</div>
<div class="line"> </div>
<div class="line">% <a class="code" href="namespaceOpenSim.html#a4286a47452ef915e89270cee497faaeca88156d46910a2d733443c339a9231d12">Velocity</a> bounds: all model coordinates should start and end at rest.</div>
<div class="line">problem.setStateInfoPattern(<span class="stringliteral">&#39;/jointset/.*/speed&#39;</span>, );</div>
<div class="line"> </div>
<div class="line">% Part 1d: Add a MocoControlGoal to the problem.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Part 1e: Configure the solver.</div>
<div class="line">solver = study.initCasADiSolver();</div>
<div class="line">solver.set_num_mesh_intervals( );</div>
<div class="line">solver.set_optim_convergence_tolerance( );</div>
<div class="line">solver.set_optim_constraint_tolerance( );</div>
<div class="line"> </div>
<div class="line"><span class="keywordflow">if</span> ~exist(<span class="stringliteral">&#39;predictSolution.sto&#39;</span>, <span class="stringliteral">&#39;file&#39;</span>)</div>
<div class="line">% Part 1f: Solve! Write the solution to file, and visualize.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">%% Part 2: Torque-driven Tracking Problem</div>
<div class="line">% Part 2a: Construct a tracking reference TimeSeriesTable using filtered </div>
<div class="line">% data from the previous solution. Use a TableProcessor, which accepts a </div>
<div class="line">% base table and allows appending operations to modify the table.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Part 2b: Add a MocoStateTrackingCost to the problem using the states</div>
<div class="line">% from the predictive problem (via the TableProcessor we just created). </div>
<div class="line">% Enable the setAllowUnusedReferences() setting to ignore the controls in</div>
<div class="line">% the predictive solution.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Part 2c: Reduce the control goal weight so it now acts as a regularization </div>
<div class="line">% term.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Part 2d: Set the initial guess using the predictive problem solution.</div>
<div class="line">% Tighten convergence tolerance to ensure smooth controls.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">if ~exist(&#39;trackingSolution.sto&#39;, &#39;file&#39;)</div>
<div class="line">% Part 2e: Solve! Write the solution to file, and visualize.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">%% Part 3: Compare Predictive and Tracking Solutions</div>
<div class="line">% This is a convenience function provided for you. See mocoPlotTrajectory.m</div>
<div class="line">mocoPlotTrajectory(&#39;predictSolution.sto&#39;, &#39;trackingSolution.sto&#39;, ...</div>
<div class="line">        &#39;predict&#39;, &#39;track&#39;);</div>
<div class="line"> </div>
<div class="line">%% Part 4: Muscle-driven Inverse Problem</div>
<div class="line">% Create a MocoInverse tool instance.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Part 4a: Provide the model via a ModelProcessor. Similar to the TableProcessor,</div>
<div class="line">% you can add operators to modify the base model.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Part 4b: Set the reference kinematics using the same TableProcessor we used</div>
<div class="line">% in the tracking problem.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Part 4c: Set the time range, mesh interval, and convergence tolerance.</div>
<div class="line">inverse.set_initial_time( );</div>
<div class="line">inverse.set_final_time( );</div>
<div class="line">inverse.set_mesh_interval( );</div>
<div class="line">inverse.set_convergence_tolerance( );</div>
<div class="line">inverse.set_constraint_tolerance( );</div>
<div class="line"> </div>
<div class="line">% Allow extra (unused) columns in the kinematics and minimize activations.</div>
<div class="line">inverse.set_kinematics_allow_extra_columns(<span class="keyword">true</span>);</div>
<div class="line">inverse.set_minimize_sum_squared_activations(<span class="keyword">true</span>);</div>
<div class="line"> </div>
<div class="line">% Append additional outputs path <span class="keywordflow">for</span> quantities that are calculated</div>
<div class="line">% post-hoc using the inverse problem solution.</div>
<div class="line">inverse.append_output_paths(&#39;.*normalized_fiber_length&#39;);</div>
<div class="line">inverse.append_output_paths(<span class="stringliteral">&#39;.*passive_force_multiplier&#39;</span>);</div>
<div class="line"> </div>
<div class="line">% Part 4d: Solve! Write the MocoSolution to file.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Part 4e: Get the outputs we calculated from the inverse solution.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">%% Part 5: Muscle-driven Inverse Problem with Passive Assistance</div>
<div class="line">% Part 5a: Create a new muscle-driven model, now adding a SpringGeneralizedForce </div>
<div class="line">% about the knee coordinate.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Part 5b: Create a ModelProcessor similar to the previous one, using the same</div>
<div class="line">% reserve actuator strength so we can compare muscle activity accurately.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Part 5c: Solve! Write solution.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">%% Part 6: Compare unassisted and assisted Inverse Problems.</div>
<div class="line">fprintf(&#39;Cost without device: %f\n&#39;, ...</div>
<div class="line">        inverseSolution.getMocoSolution().getObjective());</div>
<div class="line">fprintf(<span class="stringliteral">&#39;Cost with device: %f\n&#39;</span>, ...</div>
<div class="line">        inverseDeviceSolution.getMocoSolution().getObjective());</div>
<div class="line">% This is a convenience <span class="keyword">function</span> provided <span class="keywordflow">for</span> you. See below <span class="keywordflow">for</span> the</div>
<div class="line">% implementation.</div>
<div class="line">compareInverseSolutions(inverseSolution, inverseDeviceSolution);</div>
<div class="line"> </div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">%% Model Creation and Plotting Convenience Functions </div>
<div class="line"> </div>
<div class="line"><span class="keyword">function</span> addCoordinateActuator(model, coordName, optForce)</div>
<div class="line"> </div>
<div class="line"><span class="keyword">import</span> org.opensim.modeling.*;</div>
<div class="line"> </div>
<div class="line">coordSet = model.updCoordinateSet();</div>
<div class="line"> </div>
<div class="line">actu = CoordinateActuator();</div>
<div class="line">actu.setName([<span class="stringliteral">&#39;tau_&#39;</span> coordName]);</div>
<div class="line">actu.setCoordinate(coordSet.get(coordName));</div>
<div class="line">actu.setOptimalForce(optForce);</div>
<div class="line">actu.setMinControl(-1);</div>
<div class="line">actu.setMaxControl(1);</div>
<div class="line"> </div>
<div class="line">model.addComponent(actu);</div>
<div class="line"> </div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line"><span class="keyword">function</span> [model] = getTorqueDrivenModel()</div>
<div class="line"> </div>
<div class="line">import org.opensim.modeling.*;</div>
<div class="line"> </div>
<div class="line">% Load the base model.</div>
<div class="line">model = Model(&#39;squatToStand_3dof9musc.osim&#39;);</div>
<div class="line"> </div>
<div class="line">% Remove the muscles in the model.</div>
<div class="line">model.updForceSet().clearAndDestroy();</div>
<div class="line">model.initSystem();</div>
<div class="line"> </div>
<div class="line">% Add CoordinateActuators to the model degrees-of-freedom.</div>
<div class="line">addCoordinateActuator(model, &#39;hip_flexion_r&#39;, 150);</div>
<div class="line">addCoordinateActuator(model, &#39;knee_angle_r&#39;, 300);</div>
<div class="line">addCoordinateActuator(model, &#39;ankle_angle_r&#39;, 150);</div>
<div class="line"> </div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">function [model] = getMuscleDrivenModel()</div>
<div class="line"> </div>
<div class="line">import org.opensim.modeling.*;</div>
<div class="line"> </div>
<div class="line">% Load the base model.</div>
<div class="line">model = Model(&#39;squatToStand_3dof9musc.osim&#39;);</div>
<div class="line">model.finalizeConnections();</div>
<div class="line"> </div>
<div class="line">% Replace the muscles in the model with muscles from DeGroote, Fregly,</div>
<div class="line">% et al. 2016, &quot;Evaluation of Direct Collocation Optimal Control Problem</div>
<div class="line">% Formulations for Solving the Muscle Redundancy Problem&quot;. These muscles</div>
<div class="line">% have the same properties as the original muscles but their characteristic</div>
<div class="line">% curves are optimized for direct collocation (i.e. no discontinuities,</div>
<div class="line">% twice differentiable, etc).</div>
<div class="line">DeGrooteFregly2016Muscle().replaceMuscles(model);</div>
<div class="line"> </div>
<div class="line">% Make problems easier to solve by strengthening the model and widening the</div>
<div class="line">% active force-length curve.</div>
<div class="line">for m = 0:model.getMuscles().getSize()-1</div>
<div class="line">    musc = model.updMuscles().get(m);</div>
<div class="line">    musc.setMinControl(0);</div>
<div class="line">    musc.set_ignore_activation_dynamics(false);</div>
<div class="line">    musc.set_ignore_tendon_compliance(false);</div>
<div class="line">    musc.set_max_isometric_force(2 * musc.get_max_isometric_force());</div>
<div class="line">    dgf = DeGrooteFregly2016Muscle.safeDownCast(musc);</div>
<div class="line">    dgf.set_active_force_width_scale(1.5);</div>
<div class="line">    dgf.set_tendon_compliance_dynamics_mode(&#39;implicit&#39;);</div>
<div class="line">    if strcmp(<span class="keywordtype">char</span>(musc.getName()), &#39;soleus_r&#39;)</div>
<div class="line">        % Soleus has a very <span class="keywordtype">long</span> tendon, so modeling its tendon as rigid</div>
<div class="line">        % causes the fiber to be unrealistically <span class="keywordtype">long</span> and generate</div>
<div class="line">        % excessive passive fiber force.</div>
<div class="line">        dgf.set_ignore_passive_fiber_force(true);</div>
<div class="line">    end</div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">function compareInverseSolutions(unassistedSolution, assistedSolution)</div>
<div class="line"> </div>
<div class="line">unassistedSolution = unassistedSolution.getMocoSolution();</div>
<div class="line">assistedSolution = assistedSolution.getMocoSolution();</div>
<div class="line">figure;</div>
<div class="line">stateNames = unassistedSolution.getStateNames();</div>
<div class="line">numStates = stateNames.size();</div>
<div class="line">dim = 3;</div>
<div class="line">iplot = 0;</div>
<div class="line">for i = 0:numStates-1</div>
<div class="line">    if contains(<span class="keywordtype">char</span>(stateNames.get(i)), &#39;activation&#39;)</div>
<div class="line">        iplot = iplot + 1;</div>
<div class="line">        subplot(dim, dim, iplot);</div>
<div class="line">        plot(unassistedSolution.getTimeMat(), ...</div>
<div class="line">             unassistedSolution.getStateMat(stateNames.get(i)), &#39;-r&#39;, ...</div>
<div class="line">             &#39;linewidth&#39;, 3);</div>
<div class="line">        hold on</div>
<div class="line">        plot(assistedSolution.getTimeMat(), ...</div>
<div class="line">             assistedSolution.getStateMat(stateNames.get(i)), &#39;--b&#39;, ...</div>
<div class="line">             &#39;linewidth&#39;, 2.5);</div>
<div class="line">        hold off</div>
<div class="line">        stateName = stateNames.get(i);</div>
<div class="line">        plotTitle = stateName;</div>
<div class="line">        plotTitle = strrep(plotTitle, &#39;/forceset/&#39;, &#39;&#39;);</div>
<div class="line">        plotTitle = strrep(plotTitle, &#39;/activation&#39;, &#39;&#39;);</div>
<div class="line">        title(plotTitle, &#39;Interpreter&#39;, &#39;none&#39;);</div>
<div class="line">        xlabel(&#39;time (s)&#39;);</div>
<div class="line">        ylabel(&#39;activation (-)&#39;);</div>
<div class="line">        ylim([0, 1]);</div>
<div class="line">        if iplot == 0</div>
<div class="line">           legend(&#39;unassisted&#39;, &#39;assisted&#39;);</div>
<div class="line">        end</div>
<div class="line">    end</div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">end</div>
<div class="ttc" id="anamespaceOpenSim_html_a4286a47452ef915e89270cee497faaeca52f5e0bc3859bc5f5e25130b6c7e8881"><div class="ttname"><a href="namespaceOpenSim.html#a4286a47452ef915e89270cee497faaeca52f5e0bc3859bc5f5e25130b6c7e8881">OpenSim::KinematicLevel::Position</a></div><div class="ttdeci">@ Position</div></div>
<div class="ttc" id="anamespaceOpenSim_html_a4286a47452ef915e89270cee497faaeca88156d46910a2d733443c339a9231d12"><div class="ttname"><a href="namespaceOpenSim.html#a4286a47452ef915e89270cee497faaeca88156d46910a2d733443c339a9231d12">OpenSim::KinematicLevel::Velocity</a></div><div class="ttdeci">@ Velocity</div></div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:01 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
